<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlaceIdentifier_V4 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlaceIdentifier_V4 extends AbstractStructArrayBase
{
    /**
     * The PlaceIdentifier_V4
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlaceIdentifier_V4[]
     */
    public $PlaceIdentifier_V4;
    /**
     * Constructor method for ArrayOfPlaceIdentifier_V4
     * @uses ArrayOfPlaceIdentifier_V4::setPlaceIdentifier_V4()
     * @param \StructType\PlaceIdentifier_V4[] $placeIdentifier_V4
     */
    public function __construct(array $placeIdentifier_V4 = array())
    {
        $this
            ->setPlaceIdentifier_V4($placeIdentifier_V4);
    }
    /**
     * Get PlaceIdentifier_V4 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlaceIdentifier_V4[]|null
     */
    public function getPlaceIdentifier_V4()
    {
        return isset($this->PlaceIdentifier_V4) ? $this->PlaceIdentifier_V4 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlaceIdentifier_V4 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlaceIdentifier_V4 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlaceIdentifier_V4ForArrayConstraintsFromSetPlaceIdentifier_V4(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlaceIdentifier_V4PlaceIdentifier_V4Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlaceIdentifier_V4PlaceIdentifier_V4Item instanceof \StructType\PlaceIdentifier_V4) {
                $invalidValues[] = is_object($arrayOfPlaceIdentifier_V4PlaceIdentifier_V4Item) ? get_class($arrayOfPlaceIdentifier_V4PlaceIdentifier_V4Item) : sprintf('%s(%s)', gettype($arrayOfPlaceIdentifier_V4PlaceIdentifier_V4Item), var_export($arrayOfPlaceIdentifier_V4PlaceIdentifier_V4Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlaceIdentifier_V4 property can only contain items of type \StructType\PlaceIdentifier_V4, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlaceIdentifier_V4 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceIdentifier_V4[] $placeIdentifier_V4
     * @return \ArrayType\ArrayOfPlaceIdentifier_V4
     */
    public function setPlaceIdentifier_V4(array $placeIdentifier_V4 = array())
    {
        // validation for constraint: array
        if ('' !== ($placeIdentifier_V4ArrayErrorMessage = self::validatePlaceIdentifier_V4ForArrayConstraintsFromSetPlaceIdentifier_V4($placeIdentifier_V4))) {
            throw new \InvalidArgumentException($placeIdentifier_V4ArrayErrorMessage, __LINE__);
        }
        if (is_null($placeIdentifier_V4) || (is_array($placeIdentifier_V4) && empty($placeIdentifier_V4))) {
            unset($this->PlaceIdentifier_V4);
        } else {
            $this->PlaceIdentifier_V4 = $placeIdentifier_V4;
        }
        return $this;
    }
    /**
     * Add item to PlaceIdentifier_V4 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceIdentifier_V4 $item
     * @return \ArrayType\ArrayOfPlaceIdentifier_V4
     */
    public function addToPlaceIdentifier_V4(\StructType\PlaceIdentifier_V4 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlaceIdentifier_V4) {
            throw new \InvalidArgumentException(sprintf('The PlaceIdentifier_V4 property can only contain items of type \StructType\PlaceIdentifier_V4, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlaceIdentifier_V4[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlaceIdentifier_V4|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlaceIdentifier_V4|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlaceIdentifier_V4|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlaceIdentifier_V4|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlaceIdentifier_V4|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlaceIdentifier_V4
     */
    public function getAttributeName()
    {
        return 'PlaceIdentifier_V4';
    }
}
